/**************************************************************************

	WWWC (FirefoxOpen.dll)

	main.c

**************************************************************************/


/**************************************************************************
	Include Files
**************************************************************************/

#define _INC_OLE
#include <windows.h>
#undef  _INC_OLE

#include "wwwcdll.h"


/**************************************************************************
	Define
**************************************************************************/

#define BUF_SIZE			256			/* obt@TCY */


/**************************************************************************
	Global Variables
**************************************************************************/

static HINSTANCE g_hinst;
static char ini_path[BUF_SIZE];
static char ExeFilePath[BUF_SIZE];


/******************************************************************************

	DllMain

	C

******************************************************************************/

int WINAPI DllMain(HINSTANCE hInst, DWORD fdwReason, PVOID pvReserved)
{
	char buf[BUF_SIZE];
	char *p, *r;

	g_hinst = hInst;

	GetModuleFileName(g_hinst, buf, BUF_SIZE - 1);
	p = buf;
	while(*p != '\0'){
		if(IsDBCSLeadByte((BYTE)*p) == TRUE){
			p++;
		}else if(*p == '\\'){
			r = p;
		}
		p++;
	}
	*r = '\0';

	wsprintf(ini_path, "%s\\FirefoxOpen.ini", buf);
	GetPrivateProfileString("APP", "path", "", ExeFilePath, BUF_SIZE - 1, ini_path);
    return TRUE;
}


/******************************************************************************

	GetToolList

	c[ݒ

******************************************************************************/

__declspec(dllexport) int CALLBACK GetToolList(int cnt, struct TP_TOOLS *tpToolInfo)
{
	int ret = 0;

	switch(cnt)
	{
	case 0:
		lstrcpy(tpToolInfo->title,"ShellOpen(&P)");
		tpToolInfo->Action = TOOL_EXEC_ITEMMENU | TOOL_EXEC_INITITEM;
		lstrcpy(tpToolInfo->func,"ShellOpen");
		lstrcpy(tpToolInfo->Protocol,"http");
		tpToolInfo->MenuIndex = 2;
		break;
	case 1:
		lstrcpy(tpToolInfo->title,"FirefoxOpen(&F)");
		tpToolInfo->Action = TOOL_EXEC_ITEMMENU | TOOL_EXEC_INITITEM;
		lstrcpy(tpToolInfo->func,"FirefoxOpen");
		lstrcpy(tpToolInfo->Protocol,"http");
		tpToolInfo->MenuIndex = 2;
		break;
	case 2:
		lstrcpy(tpToolInfo->title,"FirefoxOpenLW(&W)");
		tpToolInfo->Action = TOOL_EXEC_ITEMMENU | TOOL_EXEC_INITITEM;
		lstrcpy(tpToolInfo->func,"FirefoxOpenLW");
		lstrcpy(tpToolInfo->Protocol,"http");
		tpToolInfo->MenuIndex = 2;
		break;
	default:
		ret = -1;
		break;
	}
	return ret;
}


/******************************************************************************

	ShellOpen

	pXy[X؂URLnB

******************************************************************************/

__declspec(dllexport) int CALLBACK ShellOpen(HWND hWnd, struct TPITEM **ToolItemList,
int ToolItemListCnt, int type, int CheckType)
{
	struct TPITEM *tpItemInfo;
	OPENFILENAME of;
	char *buf;
	char *p, *r;
	int len = 0;
	int i;

	//vpeB
	if(type == TOOL_EXEC_PORP){
		ZeroMemory(&of, sizeof(OPENFILENAME));
		of.lStructSize = sizeof(OPENFILENAME);
		of.hwndOwner = hWnd;
		of.lpstrTitle = "AvP[V̑I";
		of.lpstrFilter = "*.*\0*.*\0\0";
		of.lpstrFile = ExeFilePath;
		of.nMaxFile = BUF_SIZE - 1;
		of.Flags = OFN_FILEMUSTEXIST | OFN_HIDEREADONLY;

		if(GetOpenFileName((LPOPENFILENAME)&of) == TRUE){
			WritePrivateProfileString("APP", "path", ExeFilePath, ini_path);
		}
		return 1;
	}
	
	if(ToolItemListCnt <= 0 || ToolItemList == NULL){
		return 0;
	}

	if(*ExeFilePath == '\0'){
		if(MessageBox(hWnd, "NAvP[Vݒ肳Ă܂B\r\n"
			"OK ƃAvP[VI܂B",
			"ShellOpen", MB_ICONEXCLAMATION | MB_OKCANCEL) == IDCANCEL){
			return 0;
		}
		ShellOpen(hWnd, NULL, -1, TOOL_EXEC_PORP, 0);
	}

	//TCY擾
	for(i = 0; i < ToolItemListCnt; i++){
		tpItemInfo = *(ToolItemList + i);
		if(tpItemInfo == NULL){
			continue;
		}
		p = (tpItemInfo->ViewURL != NULL && *tpItemInfo->ViewURL != '\0') ? tpItemInfo->ViewURL : tpItemInfo->CheckURL;
		if(p == NULL || *p == '\0') continue;
		len ++;
		len += lstrlen(p);
	}

	r = buf = (char *)LocalAlloc(LMEM_FIXED, len + 1);
	if(buf == NULL) return 0;

	//R}hC쐬
	for(i = 0; i < ToolItemListCnt; i++){
		tpItemInfo = *(ToolItemList + i);
		if(tpItemInfo == NULL){
			continue;
		}
		p = (tpItemInfo->ViewURL != NULL && *tpItemInfo->ViewURL != '\0') ? tpItemInfo->ViewURL : tpItemInfo->CheckURL;
		if(p == NULL || *p == '\0') continue;
		*(r++) = ' ';
		lstrcpy(r, p);
		r += lstrlen(p);
	}
	*(--r) = '\0';

	ShellExecute(NULL, "open", ExeFilePath, buf, NULL, SW_SHOWNORMAL);
	LocalFree(buf);
	return 1;
}


/******************************************************************************

	ShellOpenFx

	Firefox VKEChEŊJp

******************************************************************************/

__declspec(dllexport) int CALLBACK FirefoxOpen(HWND hWnd, struct TPITEM **ToolItemList,
int ToolItemListCnt, int type, int CheckType)
{
	struct TPITEM *tpItemInfo;
	OPENFILENAME of;
	char *buf;
	char *p, *r;
	int len = 0;
	int i;

	//vpeB
	if(type == TOOL_EXEC_PORP){
		ZeroMemory(&of, sizeof(OPENFILENAME));
		of.lStructSize = sizeof(OPENFILENAME);
		of.hwndOwner = hWnd;
		of.lpstrTitle = "AvP[V̑I";
		of.lpstrFilter = "*.*\0*.*\0\0";
		of.lpstrFile = ExeFilePath;
		of.nMaxFile = BUF_SIZE - 1;
		of.Flags = OFN_FILEMUSTEXIST | OFN_HIDEREADONLY;

		if(GetOpenFileName((LPOPENFILENAME)&of) == TRUE){
			WritePrivateProfileString("APP", "path", ExeFilePath, ini_path);
		}
		return 1;
	}
	
	if(ToolItemListCnt <= 0 || ToolItemList == NULL){
		return 0;
	}

	if(*ExeFilePath == '\0'){
		if(MessageBox(hWnd, "NAvP[Vݒ肳Ă܂B\r\n"
			"OK ƃAvP[VI܂B",
			"FirefoxOpen", MB_ICONEXCLAMATION | MB_OKCANCEL) == IDCANCEL){
			return 0;
		}
		FirefoxOpen(hWnd, NULL, -1, TOOL_EXEC_PORP, 0);
	}

	//TCY擾
	for(i = 0; i < ToolItemListCnt; i++){
		tpItemInfo = *(ToolItemList + i);
		if(tpItemInfo == NULL){
			continue;
		}
		p = (tpItemInfo->ViewURL != NULL && *tpItemInfo->ViewURL != '\0') ? tpItemInfo->ViewURL : tpItemInfo->CheckURL;
		if(p == NULL || *p == '\0') continue;
		len += 3;
		len += lstrlen(p);
	}

	r = buf = (char *)LocalAlloc(LMEM_FIXED, len + 1);
	if(buf == NULL) return 0;

	//R}hC쐬
	for(i = 0; i < ToolItemListCnt; i++){
		tpItemInfo = *(ToolItemList + i);
		if(tpItemInfo == NULL){
			continue;
		}
		p = (tpItemInfo->ViewURL != NULL && *tpItemInfo->ViewURL != '\0') ? tpItemInfo->ViewURL : tpItemInfo->CheckURL;
		if(p == NULL || *p == '\0') continue;
		*(r++) = '"';
		lstrcpy(r, p);
		r += lstrlen(p);
		*(r++) = '"';
		*(r++) = '|';
	}
	*(--r) = '\0';

	ShellExecute(NULL, "open", ExeFilePath, buf, NULL, SW_SHOWNORMAL);
	LocalFree(buf);
	return 1;
}

/******************************************************************************

	ShellOpenFxLW

	Firefox ŌɃANeBuEChEŊJp

******************************************************************************/

__declspec(dllexport) int CALLBACK FirefoxOpenLW(HWND hWnd, struct TPITEM **ToolItemList,
int ToolItemListCnt, int type, int CheckType)
{
	struct TPITEM *tpItemInfo;
	OPENFILENAME of;
	char *p;
	int i;

	//vpeB
	if(type == TOOL_EXEC_PORP){
		ZeroMemory(&of, sizeof(OPENFILENAME));
		of.lStructSize = sizeof(OPENFILENAME);
		of.hwndOwner = hWnd;
		of.lpstrTitle = "AvP[V̑I";
		of.lpstrFilter = "*.*\0*.*\0\0";
		of.lpstrFile = ExeFilePath;
		of.nMaxFile = BUF_SIZE - 1;
		of.Flags = OFN_FILEMUSTEXIST | OFN_HIDEREADONLY;

		if(GetOpenFileName((LPOPENFILENAME)&of) == TRUE){
			WritePrivateProfileString("APP", "path", ExeFilePath, ini_path);
		}
		return 1;
	}
	
	if(ToolItemListCnt <= 0 || ToolItemList == NULL){
		return 0;
	}

	if(*ExeFilePath == '\0'){
		if(MessageBox(hWnd, "NAvP[Vݒ肳Ă܂B\r\n"
			"OK ƃAvP[VI܂B",
			"FirefoxOpenLW", MB_ICONEXCLAMATION | MB_OKCANCEL) == IDCANCEL){
			return 0;
		}
		FirefoxOpenLW(hWnd, NULL, -1, TOOL_EXEC_PORP, 0);
	}

	// ACe킽
	for(i = 0; i < ToolItemListCnt; i++){
		tpItemInfo = *(ToolItemList + i);
		if(tpItemInfo == NULL){
			continue;
		}
		p = (tpItemInfo->ViewURL != NULL && *tpItemInfo->ViewURL != '\0') ? tpItemInfo->ViewURL : tpItemInfo->CheckURL;
		if(p == NULL || *p == '\0') continue;
		ShellExecute(NULL, "open", ExeFilePath, p, NULL, SW_SHOWNORMAL);
	}

	return 1;
}
/* End of source */